import 'react-draft-wysiwyg/dist/react-draft-wysiwyg.css';
import FieldCoreBase, { IStateFieldBase } from '@react-form-fields/core/components/FieldCoreBase';
import { EditorState } from 'draft-js';
import * as React from 'react';
import { EditorProps } from 'react-draft-wysiwyg';
import { IBaseFieldProps } from '../../interfaces/props';
declare type PropsResolver = {
    [K in Exclude<keyof EditorProps, keyof IBaseFieldProps>]?: EditorProps[K];
};
interface IState extends IStateFieldBase {
    editorState: EditorState;
    lastValue: string;
    focused: boolean;
}
interface IProps extends IBaseFieldProps, PropsResolver {
    helperText?: React.ReactNode;
    placeholder?: string;
    disabled?: boolean;
}
export default class FieldHtml extends FieldCoreBase<IProps, IState> {
    changeTimeout: number;
    localization: {
        locale: string;
    };
    componentDidMount(): void;
    componentDidUpdate(): void;
    onChange: (editorState: EditorState) => void;
    onBlur: (e: React.SyntheticEvent<Element, Event>) => void;
    onFocus: () => void;
    handlePastedText: (text: string, html: string) => boolean;
    readonly toolbar: object;
    render(): JSX.Element;
}
export {};
